<?php

namespace Teknisa\DF\Controllers;

use Zeedhi\Framework\DTO;

class NotafiscalEspelhoNF extends \Teknisa\DF\Controllers\TeknisaCrud {

    const DATASOURCE_NOTAFISCAL_FORN_ESP = 'notafiscal_fornecedor_espelho';
    const DATASOURCE_NOTAFISCAL_CLIE_ESP = 'notafiscal_cliente_espelho';
    const DATASOURCE_NOTAFISCAL_FILI_ESP = 'notafiscal_filial_espelho';

    protected $dataSourceName = 'notafiscal_lancamento_espelho';

    protected $parameterBagColumns = array(
        'NRORG',
        'NRLANCTONF',
        'CDFILIAL'
    );

    public function find(DTO\Request\Filter $request, DTO\Response $response) {

        $filterCriteria = $request->getFilterCriteria();
        $conditions = $filterCriteria->getConditions();

        $keyRemoveIdorigdestnf = null;

        foreach ($conditions as $key => $condition) {

            if ($condition['columnName'] === 'IDORIGDESTNF') {

                $idorigdestnf = str_split($condition['value']);

                switch ($idorigdestnf) {
                    case in_array('F', $idorigdestnf):
                        $this->dataSourceName = self::DATASOURCE_NOTAFISCAL_FORN_ESP;
                        break;
                    case in_array('C', $idorigdestnf):
                        $this->dataSourceName = self::DATASOURCE_NOTAFISCAL_CLIE_ESP;
                        break;
                    case in_array('L', $idorigdestnf):
                        $this->dataSourceName = self::DATASOURCE_NOTAFISCAL_FILI_ESP;
                        break;
                }

                $keyRemoveIdorigdestnf = $key;
            }
        }

        if (is_numeric($keyRemoveIdorigdestnf))
            array_splice($conditions, $keyRemoveIdorigdestnf, 1);

        parent::find($request, $response);
    }
}